【力扣】389.找不同

问题描述

思路解析

  • 只有小写字母,这种设计参数小的,直接桶排序

  • 我最开始的想法是使用两个不同的数组,分别存入他们单个字符转换后的值,然后比较是否相同。也确实通过了

  • 看了题解后,发现可以优化,首先因为t相比于s,是增加了一个字符。那么t的对应的那个单词一定是比s多的。因此可以只用一个字符数组就可以了

  • s中++,t--,只要数组中小于0,代表就是这个数字

代码

java 复制代码
class Solution {
    public char findTheDifference(String s, String t) {
        /**
            只含有小写字母,用桶排序,然后对于0~25的数字是否一样,不一样则输出
         */
        
        int len1=s.length();
        int len2=t.length();
        int[] arr1=new int[26];
        int[] arr2=new int[26];

        for(int i=0;i<len1;i++){
            arr1[s.charAt(i)-'a']++;
        }
        for(int j=0;j<len2;j++){
            arr2[t.charAt(j)-'a']++;
        }

        char res;
        for(int i=0;i<26;i++){
            if(arr1[i]!=arr2[i])
                return (char)(i+'a');
        }
        return ' ';
    }
}

优化后代码

java 复制代码
class Solution {
    public char findTheDifference(String s, String t) {
        /**
            只含有小写字母,用桶排序,然后对于0~25的数字是否一样,不一样则输出
         */
        
        int len1=s.length();
        int len2=t.length();
        int[] arr1=new int[26];


        for(int i=0;i<len1;i++){
            arr1[s.charAt(i)-'a']++;
        }
        for(int j=0;j<len2;j++){
            char ch=t.charAt(j);
            arr1[ch-'a']--;
            if(arr1[ch-'a']<0){
                return ch;
            }
        }
        return ' ';
    }
}
相关推荐
小虎牙^O^10 分钟前
模糊数学综合评价:从模糊数学到建模评价类模型
人工智能·算法
随意起个昵称27 分钟前
【单调队列优化DP】U301134 绿色通道
算法·动态规划
Nil20843 分钟前
leetcode 739每日温度
算法·leetcode·职场和发展
lvwangshu1 小时前
势能分析(摊还分析)
数据结构·数学·算法
盘古开天16661 小时前
PPO算法代码实战(三):PyTorch从零实现PPO求解CartPole
人工智能·pytorch·算法
yyy(十一月限定版)1 小时前
CF2138A Cake Assignment
算法
盘古开天16662 小时前
PPO算法原理详解(下):Clip机制深入剖析与实践指南
人工智能·算法·机器学习
All for pursuit.2 小时前
【贪心-4】581.最短无序连续子数组
数据结构·c++·算法·leetcode
weixin_307779132 小时前
从“人操作仪器”到“Agent 自主发现”:OPL 金属材料自驱动实验室 MVP 技术论述
开发语言·人工智能·算法·架构
释厄6232 小时前
01AB 基本元理——任何智能体的三元法理·0=1→0≠1法理跃迁为天理
人工智能·windows·算法·microsoft·机器学习